
Events.OnNewGame.Add(function(player, square)
    Tekagis.checkForUpgradeInContainer(player:getInventory())
end)

local upgradeFunction = function(item, player, upgrade)
    Tekagis.upgradeItem(item, upgrade, false)
end



Events.OnFillInventoryObjectContextMenu.Add(function(player, context, items)
    local playerObj = getSpecificPlayer(player)
    if not isAdmin() then return end
    local item = items[1]
    if not instanceof(item, "InventoryItem") then item = items[1].items[1] end
    if playerObj:getInventory():contains(item) == false then return end    
    if item:getModData().UPGRADED then return end
    local upgradeTable = Tekagis.UpgradedItemsTable[item:getFullType()]
    local specialTable = Tekagis.SpecialItemsTable[item:getFullType()]
    if not upgradeTable and not specialTable then return end
    
    local upgradeMenu = context:addOption("Upgrade to", item, nil)
    local subMenu = context:getNew(context)
    context:addSubMenu(upgradeMenu, subMenu)
    if upgradeTable then
        for _, upgrade in ipairs(upgradeTable) do
            local name = upgrade.absolute.Name
            subMenu:addOption(name, item, upgradeFunction, player, upgrade)
        end
    end
    if specialTable then
        for _, upgrade in ipairs(specialTable) do
            local name = upgrade.absolute.Name
            subMenu:addOption(name, item, upgradeFunction, player, upgrade)
        end
    end
end)

Events.OnEquipPrimary.Add(Tekagis.onEquipTraitCheck)
Events.OnEquipSecondary.Add(Tekagis.onEquipTraitCheck)

Events.OnGameStart.Add(function()
    --Events.EveryTenMinutes.Add(Tekagis.tenMinuteTraitCheck)
    Timers.add(1, true, Tekagis.tenMinuteTraitCheck, nil)
    if NecroList then -- necroforge is loaded.

        local TekagisItems = {
            "BookStrength1", "BookStrength2", "BookStrength3", "BookStrength4", "BookStrength5",
            "BookFitness1", "BookFitness2", "BookFitness3", "BookFitness4", "BookFitness5",
            "BookSprinting1", "BookSprinting2", "BookSprinting3", "BookSprinting4", "BookSprinting5",
            "BookSneak1", "BookSneak2", "BookSneak3", "BookSneak4", "BookSneak5",
            "BookNimble1", "BookNimble2", "BookNimble3", "BookNimble4", "BookNimble5",
            "BookLightfoot1", "BookLightfoot2", "BookLightfoot3", "BookLightfoot4", "BookLightfoot5",
            "BookAiming1", "BookAiming2", "BookAiming3", "BookAiming4", "BookAiming5",
            "BookReloading1", "BookReloading2", "BookReloading3", "BookReloading4", "BookReloading5",
            "BookBlunt1", "BookBlunt2", "BookBlunt3", "BookBlunt4", "BookBlunt5",
            "BookBluntGuard1", "BookBluntGuard2", "BookBluntGuard3", "BookBluntGuard4", "BookBluntGuard5",
            "BookBluntMaintenance1", "BookBluntMaintenance2", "BookBluntMaintenance3", "BookBluntMaintenance4", "BookBluntMaintenance5",
            "BookBlade1", "BookBlade2", "BookBlade3", "BookBlade4", "BookBlade5",
            "BookBladeGuard1", "BookBladeGuard2", "BookBladeGuard3", "BookBladeGuard4", "BookBladeGuard5",
            "BookBladeMaintenance1", "BookBladeMaintenance2", "BookBladeMaintenance3", "BookBladeMaintenance4", "BookBladeMaintenance5",
        }
    
        local addTeksItem = function(index, itemName)
            -- function to save much redundant typing of entries
            local scriptItem = getScriptManager():FindItem(itemName)
            if not scriptItem then return end
            NecroList.Items["Tekagis"..index] = {"Mods", "Tekagis", nil, "Tekagis - " .. scriptItem:getDisplayName(), itemName, "media/textures/Item_" .. scriptItem:getIcon() .. ".png", nil, nil, nil} 
        end
        
        local index = 1
        for _, name in pairs(TekagisItems) do
            addTeksItem(index, 'Tekagis.'..name) 
            index = index+1
        end
    end
end
)
Events.OnFillWorldObjectContextMenu.Add(function(player, context, worldobjects, test)
    local playerObj = getSpecificPlayer(player)
    local inventory = playerObj:getInventory()
    
    local powerOff = (SandboxVars.ElecShutModifier >= -1 and GameTime:getInstance():getNightsSurvived() > SandboxVars.ElecShutModifier)
    local isPump = nil
    for _, obj in ipairs(worldobjects) do
        local square = obj:getSquare()
        --if square:getProperties():Is("fuelAmount") then print("fuel = "..tostring(tonumber(square:getProperties():Val("fuelAmount")))) end
        if square:getProperties():Is("fuelAmount") and tonumber(square:getProperties():Val("fuelAmount")) > 0 then
            isPump = obj
            break
        end
    end

    if powerOff and isPump then
        --------------------------------------------------------------------------------------
        -- Pump handling
        local hasGasCan = inventory:FindAndReturn("EmptyPetrolCan")
        if not hasGasCan then
            local items = inventory:getItemsFromType("PetrolCan");
            for i = 0, items:size() -1 do
                if items:get(i):getUsedDelta() <= 1.0 then
                    hasGasCan = items:get(i)
                    break
                end
            end
        end
        if hasGasCan and Tekagis.findNearbyGenerator(isPump, 20, 0) then
            context:addOption(getText("ContextMenu_TakeGasFromPump"), worldobjects, ISWorldObjectContextMenu.onTakeFuel, playerObj, isPump:getSquare())
        end
    end
--[[
    local option = nil
    for _, opt in pairs(context.options) do
        if opt.name == getText("ContextMenu_SafehouseClaim") then 
            option = opt
            break
        end
    end
    if option and option.toolTip.description == "Non-residential building. Cannot be claimed." then
        option.notAvailable = false
        option.toolTip = nil
        option.onSelect = claimNonResidential
    end
]]
end)
--[[
local old = ISWalkToTimedAction.update
function ISWalkToTimedAction:update()
    old(self)
    --self.spriteFrame = self.character:getSpriteDef():getFrame()
    --self.character:PlayAnimNoReset("Run")
end

local ostart = ISWalkToTimedAction.start
function ISWalkToTimedAction:start()
    ostart(self)
    --print(tostring(self.pathfindBehaviour:running(self.character)))
end

local ostop = ISWalkToTimedAction.stop
function ISWalkToTimedAction:stop()
    ostop(self)
    --print(tostring(self.pathfindBehaviour:running(self.character)))
    self.character:PlayAnim("Run")
end

]]